function wpwhoosh_site_confirm_delete($name) {
	return confirm("You are about to delete the site  "+$name+"\n Press `Cancel` to stop, `OK` to delete." );
}


function wpwhoosh_set_button_actions() {
	jQuery('#install, #check, #save, #save2, #update, #update2').each( function() {
		if (jQuery(this).hasClass('whoosh')) {
			jQuery(this).click( function() {
				jQuery('div#message').remove(); //clear any message
				action = jQuery(this).attr('id'); 
				jQuery('input[name=action]').val(action); //change action field
			});
		}
	});
}

function wpwhoosh_check_pin() {
	var secret = '';
	var pin=prompt('Please enter your PIN to authorize the use of your credits','');
	if ((pin==null) || (pin=='')) return false;
	var ts = Math.round((new Date()).getTime() / 1000).toString();
	var p = CryptoJS.MD5(pin);
	if (p) secret = CryptoJS.MD5(p.toString()+ts);
	if (secret.toString().length > 0) {
		jQuery('form#site_form').append(
			'<input type="hidden" name="time" value="'+ts+'"/><input type="hidden" name="hash" value="'+secret.toString()+'"/>');
		return true;
	} else {
			return false;
	}
}

function wpwhoosh_set_validator() {
    jQuery('#site_form').validate({
      rules: {
        site_name: { required: true },
        site_url: { required: true, url: true },
        template: { required: true },
        host: { required: true },
        site_db_name: { nowhitespace: true, maxlength: 32 },
        site_db_user: { nowhitespace: true, maxlength: 7},
        site_db_password: { nowhitespace: true, maxlength: 32 },
        site_admin_email: { required: true, email : true },
        site_admin_name: { required: true, maxlength: 32 },
        site_copyright_start: {min: 1900, max: 2020 },
        site_twitter_name : { nowhitespace: true, alphanumeric: true, maxlength: 15 },
        site_facebook_url : { url: true, maxlength: 100 },
        site_flickr_id : { nowhitespace: true, maxlength: 15 },
        site_ga_code : { nowhitespace: true, maxlength: 25 }
      },
      messages: {
        site_name: "Enter a short name for your site",
        site_url: { 
        	required: "Enter the URL where you want to install the site",
        	url: "The URL should be of the form http://www.yoursite.com"
        	},        
        template: "Choose a template for your site",
        host: "Select a host",
        site_db_name: { 
        	nowhitespace: "The database name cannot contain spaces", 
        	maxlength: "The database name is limited to 32 characters" 
        },
        site_db_user: { 
        	nowhitespace: "The database username cannot contain spaces", 
        	maxlength: "The database name is limited to 7 characters" 
        },
        site_db_name: { 
        	nowhitespace: "The database password cannot contain spaces", 
        	maxlength: "The database password is limited to 32 characters" 
        },
        site_admin_email: {
       		required: "Enter your preferred WordPress administrator email address",
       		email: "The email address must be in the format of yourname@domain.com"
     	},
        site_admin_name: {
       		required: "Enter the public name that will appear on any post authored by your admin account",
        	maxlength: "The longest allowed name is 32 characters long." 
     	},     	
        site_twitter_name : { 
        	nowhitespace: "Enter a single twitter name", 
        	alphanumeric: "A twitter name can only consist of letters, numbers and underscores.", 
        	maxlength: "The longest allowed twitter name is 15 characters long." 
        },
        site_facebook_url: { 
        	url: "The Facebook URL should typically be of the form https://www.facebook.com/yourpage or http://yourname.fbfollow.me"
        }, 
        site_flickr_id : { 
        	nowhitespace: "Enter a single Flickr ID of the form 12345678@N00", 
        	maxlength: "The longest allowed Flickr ID is 15 characters long." 
        },      
        site_ga_code : { 
        	nowhitespace: "Enter a single Google Analytics code of the form UA-1234567-89", 
        	maxlength: "The longest allowed Google Analytics code is 25 characters long." 
        }           
      },
      submitHandler: function(form) {
        
        jQuery('input.wpwhoosh_action').attr("disabled", "disabled"); //stop extra clicks
      	action = jQuery('input[name=action]').val(); //get action
      	pin = jQuery('input[name=pin]').val(); //is pin required?
		if (('install'==action) && (1==pin) && !wpwhoosh_check_pin()) return false;
		if (('check'==action) || ('install'==action))
       		jQuery('#awaiting'+action).show(); //show waiting icon if required
        form.submit();
      },       
    });
}

/*
jQuery.validator.addMethod("flickrID", function(value, element, params) { 
    return this.optional(element) || /^\d+(@[A-Z]\d{2})$/i.test(value); 
}, $.format("Please enter a Flickr ID of the form 12334444@X56 - numbers @ single upper case letter then 2 digits"));
*/

jQuery(document).ready(function() {

	jQuery('.site-metabox-tabs li.tab a').each(function(i) {
		var thisTab = jQuery(this).parent().attr('class').replace(/tab /, '');
		if ( thisTab == 'tab1')
			jQuery(this).addClass('active');
		else
			jQuery(this).parent().parent().parent().find('div.' + thisTab).hide();

 		if (! jQuery(this).parent().parent('ul').hasClass('disabled'))
			jQuery(this).click(function(){
				jQuery(this).parent().parent().parent().children('div').hide();
				jQuery(this).parent().parent('ul').find('li a.active').removeClass('active');
				jQuery(this).parent().parent().parent().find('div.'+thisTab).show();
				jQuery(this).parent().parent().parent().find('li.'+thisTab+' a').addClass('active');
			});
		jQuery('.site-heading').hide();
		jQuery('.site-metabox-tabs').show();
	});
	jQuery('.wpwhoosh-date').each(function(i) {
		if (jQuery(this).text().length > 0) {
			var d=new Date(jQuery(this).text());
			jQuery(this).text(d.toLocaleString());
		}
	});
    jQuery('input[type=password]').each(function(i) {
    	jQuery(this).addClass('password').after('<input style="display:none;" disabled="disabled" class="password" type="text" size="10" value="'+jQuery(this).val()+'" autocomplete="off" /><span style="cursor:pointer"><sup>Show</sup></span>');
		jQuery(this).next().next().click( function() {
			jQuery(this).prevAll('.password').toggle();
			jQuery(this).find('sup').text(jQuery(this).text() =='Show' ? 'Hide' :'Show');
		});
		jQuery(this).change( function() {
			jQuery(this).next().val(jQuery(this).val());
		});		
	});
	wpwhoosh_set_validator();
	wpwhoosh_set_button_actions();
});